/*
CRM API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package crmapi

import (
	"encoding/json"
	"time"
)

// checks if the DNConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DNConfiguration{}

// DNConfiguration struct for DNConfiguration
type DNConfiguration struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	ClientId string `json:"client_id"`
	ApiUrl string `json:"api_url"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewDNConfiguration instantiates a new DNConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDNConfiguration(id string, organizationId string, clientId string, apiUrl string, createdAt time.Time, updatedAt time.Time) *DNConfiguration {
	this := DNConfiguration{}
	this.Id = id
	this.OrganizationId = organizationId
	this.ClientId = clientId
	this.ApiUrl = apiUrl
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewDNConfigurationWithDefaults instantiates a new DNConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDNConfigurationWithDefaults() *DNConfiguration {
	this := DNConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *DNConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *DNConfiguration) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *DNConfiguration) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *DNConfiguration) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetClientId returns the ClientId field value
func (o *DNConfiguration) GetClientId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetClientIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ClientId, true
}

// SetClientId sets field value
func (o *DNConfiguration) SetClientId(v string) {
	o.ClientId = v
}

// GetApiUrl returns the ApiUrl field value
func (o *DNConfiguration) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *DNConfiguration) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *DNConfiguration) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *DNConfiguration) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *DNConfiguration) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *DNConfiguration) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *DNConfiguration) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o DNConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DNConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["client_id"] = o.ClientId
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableDNConfiguration struct {
	value *DNConfiguration
	isSet bool
}

func (v NullableDNConfiguration) Get() *DNConfiguration {
	return v.value
}

func (v *NullableDNConfiguration) Set(val *DNConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullableDNConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullableDNConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDNConfiguration(val *DNConfiguration) *NullableDNConfiguration {
	return &NullableDNConfiguration{value: val, isSet: true}
}

func (v NullableDNConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDNConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


